
// SetIDDlg.cpp : implementation file
//-----------------------------------
#include "stdafx.h"
#include "SetID.h"
#include "SetIDDlg.h"
#include "MDBEngine.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CSetIDDlg dialog
//-----------------

CSetIDDlg::CSetIDDlg(CWnd* pParent)	: CDialog(CSetIDDlg::IDD, pParent)
//====================================================================
{
	//{{AFX_DATA_INIT(CSetIDDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSetIDDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	if (pDX->m_bSaveAndValidate)
	{
		switch (GetCheckedRadioButton(IDC_RADIO1,IDC_RADIO9))
		{
			case IDC_RADIO1:
			{
				m_dwSelected=256;
				break;
			}
			case IDC_RADIO2:
			{
				m_dwSelected=257;
				break;
			}
			case IDC_RADIO3:
			{
				m_dwSelected=258;
				break;
			}
			case IDC_RADIO4:
			{
				m_dwSelected=259;
				break;
			}
			case IDC_RADIO5:
			{
				m_dwSelected=260;
				break;
			}
			case IDC_RADIO6:
			{
				m_dwSelected=261;
				break;
			}
			case IDC_RADIO7:
			{
				m_dwSelected=262;
				break;
			}
			case IDC_RADIO8:
			{
				m_dwSelected=263;
				break;
			}
			case IDC_RADIO9:
			{
				m_dwSelected=0;
				break;
			}
		}
	}
	else
	{
		switch (m_dwSelected)
		{
			case 256:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO1);
				break;
			}
			case 257:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO2);
				break;
			}
			case 258:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO3);
				break;
			}
			case 259:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO4);
				break;
			}
			case 260:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO5);
				break;
			}
			case 261:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO6);
				break;
			}
			case 262:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO7);
				break;
			}
			case 263:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO8);
				break;
			}
			case 0:
			{
				CheckRadioButton(IDC_RADIO1,IDC_RADIO9,IDC_RADIO9);
				break;
			}
		}
	}
	//{{AFX_DATA_MAP(CSetIDDlg)
	DDX_Control(pDX, IDC_DEVICE, m_Device);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetIDDlg, CDialog)
	//{{AFX_MSG_MAP(CSetIDDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_BN_CLICKED(IDC_RADIO1, OnSelect)
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_BN_CLICKED(IDC_RADIO2, OnSelect)
	ON_BN_CLICKED(IDC_RADIO3, OnSelect)
	ON_BN_CLICKED(IDC_RADIO4, OnSelect)
	ON_BN_CLICKED(IDC_RADIO5, OnSelect)
	ON_BN_CLICKED(IDC_RADIO6, OnSelect)
	ON_BN_CLICKED(IDC_RADIO7, OnSelect)
	ON_BN_CLICKED(IDC_RADIO8, OnSelect)
	ON_BN_CLICKED(IDC_RADIO9, OnSelect)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CSetIDDlg message handlers
//---------------------------

BOOL CSetIDDlg::OnInitDialog()
//============================
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE); // Set small icon
	
	// Get current device ID
	//----------------------
	GetDeviceID(0,&m_dwSelected);
	UpdateData(false);
	Custom();
	return TRUE;
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CSetIDDlg::OnPaint() 
//=======================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND,(WPARAM)dc.GetSafeHdc(),0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
//------------------------------------------------------

void CSetIDDlg::Custom()
//======================
{
	CString sText;
	sText.Format(_T("%u"),m_dwSelected);
	m_Device.SetWindowText(sText);
	if (m_dwSelected==0)
		m_Device.SetReadOnly(false);
	else
		m_Device.SetReadOnly(true);
}

void CSetIDDlg::OnAboutbox() 
//==========================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

HCURSOR CSetIDDlg::OnQueryDragIcon()
//==================================
{
	return (HCURSOR)m_hIcon;
}

void CSetIDDlg::OnSelect() 
//========================
{
	UpdateData(true);
	Custom();
}

void CSetIDDlg::OnSet() 
//=====================
{
	UpdateData(true);
	SetDeviceID(0,m_dwSelected);
	ResetTarget(0);
}

void CSetIDDlg::OnRefresh() 
//=========================
{
	GetDeviceID(0,&m_dwSelected);	
	UpdateData(false);
	Custom();
}
